package net.locusworks.common.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation that will map a POJO to a map object.
 * This is at the field level and will map the
 * filed name as the key and the field value as the value
 * in the map
 * @author Isaac Parenteau
 *
 */
@Target({ElementType.FIELD})
@Retention(RetentionPolicy.RUNTIME)
public @interface MapValue {

  String value() default "";

  boolean ignore() default false;

}
