package net.locusworks.common.crypto;

import java.io.Serial;
import java.security.PrivateKey;

import net.locusworks.common.Charsets;

public class AESKey implements PrivateKey {
  
  @Serial private static final long serialVersionUID = -8452357427706386362L;
  private final String seed;
  
  public AESKey(String seed) {
    this.seed = seed;
  }

  @Override
  public String getAlgorithm() {
    return "aes";
  }

  @Override
  public String getFormat() {
    return "aes-seed";
  }

  @Override
  public byte[] getEncoded() {
    return this.seed.getBytes(Charsets.UTF_8);
  }
}
