package net.locusworks.common.properties;

import java.io.Serial;
import java.util.Properties;

public class ImmutableProperties extends Properties {

  @Serial private static final long serialVersionUID = 65942088008978137L;
  
  public ImmutableProperties() {
   super();
  }
  
  public ImmutableProperties(Properties props) {
    super();
    if (props == null || props.isEmpty()) return;

    this.putAll(props);
  }
  
  @Override
  public synchronized Object setProperty(String key, String value) {
    return put(key, value);
  }
  
  public synchronized Object put(Object key, Object value) {
    if (containsKey(key)) 
      throw new RuntimeException("Cannot change key value once its set: " + key);
    return super.put(key, value);
  }

}
