package net.locusworks.common.utils;

import java.util.Objects;

public class Checks {
  
  public static void checkArguments(boolean expression, String error) {
    checkArguments(expression, "%s", error);
  }
  
  public static void checkArguments(boolean expression, String errorFmt, Object... args) {
    if (!expression) throw new IllegalArgumentException(String.format(errorFmt, args));
  }
  
  public static void checkState(boolean expression, String error) {
    checkState(expression, "%s", error);
  }
  
  public static void checkState(boolean expression, String errorFmt, Object... args) {
    if (!expression) throw new IllegalStateException(String.format(errorFmt, args));
  }
  
  public static void checkNotNull(Object item, String error) {
    Objects.requireNonNull(item, error);
  }

}
