package net.locusworks.common.utils;

import com.fasterxml.jackson.annotation.ObjectIdGenerator;
import com.fasterxml.jackson.core.*;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.introspect.Annotated;
import com.fasterxml.jackson.databind.introspect.BeanPropertyDefinition;
import com.fasterxml.jackson.databind.ser.impl.WritableObjectId;
import org.junit.jupiter.api.Test;

import java.io.InputStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;
import java.util.concurrent.atomic.AtomicLong;

import static org.junit.jupiter.api.Assertions.*;

class DateTimeStampSerializerTest {

  static AtomicLong atomicLong = new AtomicLong(0);

  @Test
  void testSerializer(){
    DateTimeStampSerializer serializer = new DateTimeStampSerializer();
    assertDoesNotThrow(() -> serializer.serialize(new Date(), new MyJsonGenerator(), new MySerializerProvider()));
    assertTrue(atomicLong.get() > 0);
  }

  private static class MyJsonGenerator extends JsonGenerator {
    @Override public JsonGenerator setCodec(ObjectCodec objectCodec) {
      return null;
    }

    @Override public ObjectCodec getCodec() {
      return null;
    }

    @Override public Version version() {
      return null;
    }

    @Override public JsonStreamContext getOutputContext() {
      return null;
    }

    @Override public JsonGenerator enable(Feature feature) {
      return null;
    }

    @Override public JsonGenerator disable(Feature feature) {
      return null;
    }

    @Override public boolean isEnabled(Feature feature) {
      return false;
    }

    @Override public int getFeatureMask() {
      return 0;
    }

    @Override public JsonGenerator setFeatureMask(int i) {
      return null;
    }

    @Override public JsonGenerator useDefaultPrettyPrinter() {
      return null;
    }

    @Override public void writeStartArray() {
      fail();
    }

    @Override public void writeEndArray() {
      fail();
    }

    @Override public void writeStartObject() {
      fail();
    }

    @Override public void writeEndObject() {
      fail();
    }

    @Override public void writeFieldName(String s) {
      fail();
    }

    @Override public void writeFieldName(SerializableString serializableString)
      {
      fail();
    }

    @Override public void writeString(String s) {
      fail();
    }

    @Override public void writeString(char[] chars, int i, int i1) {
      fail();
    }

    @Override public void writeString(SerializableString serializableString) {
      fail();
    }

    @Override public void writeRawUTF8String(byte[] bytes, int i, int i1) {
      fail();
    }

    @Override public void writeUTF8String(byte[] bytes, int i, int i1) {
      fail();
    }

    @Override public void writeRaw(String s) {
      fail();
    }

    @Override public void writeRaw(String s, int i, int i1) {
      fail();
    }

    @Override public void writeRaw(char[] chars, int i, int i1) {
      fail();
    }

    @Override public void writeRaw(char c) {
      fail();
    }

    @Override public void writeRawValue(String s) {
      fail();
    }

    @Override public void writeRawValue(String s, int i, int i1) {
      fail();
    }

    @Override public void writeRawValue(char[] chars, int i, int i1) {
      fail();
    }

    @Override public void writeBinary(Base64Variant base64Variant, byte[] bytes, int i, int i1)
      {
      fail();
    }

    @Override public int writeBinary(Base64Variant base64Variant, InputStream inputStream, int i)
      {
      fail();
      return 0;
    }

    @Override public void writeNumber(int i) {
      fail();
    }

    @Override public void writeNumber(long l) {
      atomicLong.set(l);
    }

    @Override public void writeNumber(BigInteger bigInteger) {
      fail();
    }

    @Override public void writeNumber(double v) {
      fail();
    }

    @Override public void writeNumber(float v) {
      fail();
    }

    @Override public void writeNumber(BigDecimal bigDecimal) {
      fail();
    }

    @Override public void writeNumber(String s) {
      fail();
    }

    @Override public void writeBoolean(boolean b) {
      fail();
    }

    @Override public void writeNull() {
      fail();
    }

    @Override public void writeObject(Object o) {
      fail();
    }

    @Override public void writeTree(TreeNode treeNode) {
      fail();
    }

    @Override public void flush() {
      fail();
    }

    @Override public boolean isClosed() {
      return false;
    }

    @Override public void close() {
      fail();
    }
  }


  private static class MySerializerProvider extends SerializerProvider {
    @Override
    public WritableObjectId findObjectId(Object o, ObjectIdGenerator<?> objectIdGenerator) {
      return null;
    }

    @Override public JsonSerializer<Object> serializerInstance(Annotated annotated, Object o) {
      return null;
    }

    @Override public Object includeFilterInstance(BeanPropertyDefinition beanPropertyDefinition,
      Class<?> aClass) {
      return null;
    }

    @Override public boolean includeFilterSuppressNulls(Object o) {
      return false;
    }
  }
}
