package net.locusworks.common.utils;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

public class RandomStringTest {

  @Test
  public void testStaticBytes() {
    for (int length = 3; length < 50; length++) {
      assertEquals(RandomString.getInstance().getBytes(length).length, length);
    }
  }
  
  @Test
  public void testStaticString() {
    for (int length = 3; length < 50; length++) {
      String random = RandomString.getInstance().getString(length);
      assertEquals(random.length(), length);
    }
  }

  @Test
  public void testExceptions() {
    assertThrows(IllegalArgumentException.class, () -> RandomString.newInstance().getString(0));
  }

}
