package net.locusworks.test;

import net.locusworks.common.crypto.AES;
import net.locusworks.common.utils.Utils;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class AESEncryptionTest {

  @Test
  public void testEncryption() {
    try {
      String encrypted = AES.createInstance().encrypt("hello world");
      assertFalse(Utils.isEmptyString(encrypted), String.format("Encrypted String is not blank? :%s", encrypted));
    } catch (Exception ex) {
      ex.printStackTrace(System.err);
      fail();
    }
  }

  @Test
  public void testDecryption() {
    String testString ="hello world";
    try {
      AES aes = AES.createInstance();
      String encrypted = aes.encrypt(testString);
      assertFalse(Utils.isEmptyString(encrypted), String.format("Encrypted String is not blank? :%s",  encrypted));
      
      String decrypted = aes.decrypt(encrypted);
      assertFalse(Utils.isEmptyString(encrypted), String.format("Decrypted String is not blank? :%s",  decrypted));

      assertEquals(testString, decrypted, "Test String and Original String the same? :%s");
      
    } catch (Exception ex) {
      ex.printStackTrace(System.err);
      fail();
    }
  }

}
