package net.locusworks.test;

import net.locusworks.common.crypto.HashSalt;
import net.locusworks.common.utils.Utils;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class HashSaltTest {
  
  private static final String samplePassword="Hello World";

  @Test
  public void testEncryption() {
    try {
      String hashSalt = HashSalt.createHash(samplePassword);
      assertFalse(Utils.isEmptyString(hashSalt), String.format("Encrypted String is not blank? :%s", hashSalt));
    } catch(Exception ex) {
      fail();
    }
  }
  
  @Test
  public void testDecryption() {
    try {
      String hashSalt = HashSalt.createHash(samplePassword);
      boolean decrypted = HashSalt.validatePassword(samplePassword, hashSalt);
      assertTrue(decrypted, "Test String and Original String the same? :%s");
    } catch(Exception ex) {
      fail();
    }
  }

}
