package net.locusworks.test;

import net.locusworks.common.immutables.Pair;
import net.locusworks.common.immutables.Triplet;
import net.locusworks.common.immutables.Unit;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;


public class ImmutablesTest {

  @Test
  public void testUnit() {
    Unit<String> unit = new Unit<>("Hello World");
    assertEquals("Hello World", unit.getValue1());
    Unit<Integer> unit2 = new Unit<>(2);
    assertEquals(2, (int) unit2.getValue1());
  }
  
  @Test
  public void testPair() {
    Pair<String, String> pair1 = new Pair<>("Hello", "World");
    assertEquals("Hello", pair1.getValue1());
    assertEquals("World", pair1.getValue2());
    
    Pair<String, Integer> pair2 = new Pair<>("Foo", 25);
    assertEquals("Foo", pair2.getValue1());
    assertEquals(25, (int) pair2.getValue2());
    
    Pair<Integer, Integer> pair3 = new Pair<>(1, 23);
    assertEquals(1, (int) pair3.getValue1());
    assertEquals(23, (int) pair3.getValue2());
  }
  
  @Test
  public void testTriplet() {
    Triplet<String, Integer, String> triplet1 = new Triplet<>("Hello", 24, "World");
    assertEquals("Hello", triplet1.getValue1());
    assertEquals(24, (int) triplet1.getValue2());
    assertEquals("World", triplet1.getValue3());
  }

}
